/*
 *  KANJI $BF~=PNO%k!<%A%s(B
 *                        copyrighted by H. Takahasi@tiny.or.jp 1992
 *
 *  $B$3$N%b%8%e!<%k$K$O4A;z$N=hM}$K4X$9$k%k!<%A%s$,4^$^$l$^$9!#(B
 *
 *
 *  1. $B4A;z%3!<%I$NFbItI=8=(B
 *
 *  $B8=:_$N%P!<%8%g%s$G$OFbIt$O(B UJIS $B$GI=8=$7$F$$$^$9!#$7$+$7>-MhB?8@8l(B
 *  $B$N%5%]!<%H$N$?$a$K(B MULE $BEy$HF1$8$h$&$JI=8=7A<0$KJQ99$9$k2DG=@-$,$"(B
 *  $B$j$^$9$N$G!"$5$i$K%Q%C%A$dJQ99$r2C$($k>l9g$K$D$$$F$OCm0U$r$7$F$/$@(B
 *  $B$5$$!#(B
 *
 *  2. $B4A;z%U%!%$%k$N07$$(B
 *
 *  $B4A;z$r07$&%U%!%$%k$ODL>o$N(B file descritor $B$K2C$($F!"4A;zI=8=$N>uBV(B
 *  $B$d;HMQ$9$k4A;z%3!<%I!"F~=PNO$N<1JL$N$?$a$N9=B$BN$r;}$A$^$9!#(B
 *  $B9=B$BN$X$N%]%$%s%?$O(B fileno $B$r;HMQ$7$^$9!#>\:Y$K$D$$$F(B
 *  $B$O$3$N%W%m%0%i%`$r;2>H$7$F$/$@$5$$!#(B
 *
 *  $BDL>o$N%U%!%$%k$G$O(B open $B;~$K4A;z%3!<%I$r;XDj$7$^$9!#$?$@$7!"(Bstdin
 *  stdout, stderr $B$K$D$$$F$OFC<l$J07$$$H$J$j$^$9!#(B
 *  $B$3$l$i$O%W%m%0%i%`3+;O;~$KB>$NJ}K!$K$h$jFCDj$N4A;z%3!<%I$,3d$j$"$F(B
 *  $B$i$l$^$9!#(B
 *  stdout, stderr $B$K$D$$$F$O(B KANJIIN KANJIOUT $B$,O"F0$7$^$9!#(B
 *
 *  3. $B4A;z$r07$&$?$a$N%k!<%A%s(B
 *
 *  a. kanji_init(int stdin_kanji_code, int stdout_kanji_code,
 *                int stderr_kanji_code)
 *
 *     $B4D6-JQ?t$+$i%G%U%)%k%H$N4A;z%3!<%I$r7hDj$7$^$9!#(B
 *     stdin, stdout, stderr $B$K$D$$$F;XDj$,$"$l$P@_Dj$7$^$9!#(B
 *     $B$G$J$1$l$P%G%U%)%k%H$K$J$j$^$9!#(B
 *
 *  b. kanji_fopen(char *file_name, char *type, int kanji_code)
 *     kanji_fclose(FILE *fp)
 *     kanji_popen(char *command, char *type, int kanji_code)
 *     kanji_pclose(FILE *fp)
 *     kanji_fdopen(int fd, char *type, int kanji_code)
 *
 *     $B4A;z%3!<%I$r;XDj$7$F%U%!%$%k$r%*!<%W%s$7$^$9!#(B
 *     $B%/%m!<%:$N;~$K$O>uBV$,(B KANJI IN $B$K$J$C$F$$$l$P!"$3$l$rLa$7$^$9!#(B
 *
 *  c. kanji_fseek(FILE *fp, long offset, int ptrname)
 *
 *     $BF~NO$N(B KANJI IN $B$r%j%;%C%H$7$F!"(Bfseek $B$r9T$$$^$9!#(B
 *
 *  d. kanji_fgetc(FILE *fp)
 *     kanji_gets(char *string)
 *     kanji_fgets(char *string, int length, FILE *fp)
 *
 *     $B$4B8CNI8=`F~NO4X?t$G$9!#(B
 *
 *  e. kanji_fputc(int character, FILE *fp)
 *     kanji_fputs(unsigned char *string)
 *     kanji_printf(char *format, ,,,)
 *     kanji_fprintf(FILE *fp, char *format, ,,,)
 *
 *     $B$4B8CNI8=`=PNO4X?t$G$9!#(B
 *
 *  f. kanji_fread (char *ptr, int size, int nitems, FILE *stream)
 *     kanji_fwrite(char *ptr, int size, int nitems, FILE *stream)
 *
 *     $B$3$l$b$4B8CNF~=PNO4X?t$G$9!#(BNOCONV $B0J30$G$O6KC<$K8zN($,Dc2<$7$^$9!#(B
 *
 *  g. kanji_cvins (char *ptr)
 *
 *     $BM?$($i$l$?(B JIS $BI=8=J8;zNs$rFbItI=8=$KJQ49$7$^$9!#(BNNTP $B$NF~NO$J$I$G(B
 *     $B;HMQ$7$^$9!#(B($B8=:_$O85$NJ8;zNs$h$jD9$/$J$k$3$H$O$"$j$^$;$s$,!">-Mh$O(B
 *     $B$"$j$($k$N$GCm0U$7$F$/$@$5$$!#(B)
 *
 */

#define  KINTERN
#include "kanji_config.h"

#include <varargs.h>

#ifndef NEED_VSPRINTF
extern int vsprintf();
#endif

/* utils */

int strlcmp(str, pat)
register char *str;
register char *pat;
{
    register int c1, c2;

    for(;(*str != '\0') && (*pat != '\0'); ++str, ++pat) {
	c1 = (('A' <= *str) && (*str <= 'Z')) ? *str - 'A'+'a' : *str;
	c2 = (('A' <= *pat) && (*pat <= 'Z')) ? *pat - 'A'+'a' : *pat;
	if (c1 != c2) return c1-c2;
    }
    return (*pat == '\0') ? 0 : 1;
}

int decide_kanji_code(str)
register char *str;
{
    if (str == NULL)
	return DEFAULT;
    if (strlcmp(str, "sjis") == 0)
	return SJIS;
    else if ((strlcmp(str, "euc") == 0) ||
	     (strlcmp(str, "ujis") == 0) ||
	     (strlcmp(str, "dec") == 0))
        return EUC;
    else if ((strlcmp(str, "jis") == 0) ||
	     (strlcmp(str, "newjis") == 0) ||
	     (strlcmp(str, "oldjis") == 0))
	return JIS;
    else
	return DEFAULT;
}

init_kiobuf()
{
    register int i;

    for(i=0; i < DYNAMICFIO; ++ i)
	_kassoc[i] = -1;
    for(i=0; i < MAXFIO; ++ i)
	_kiobuf[i].kanji_code = NOCONV;
}

get_kiobuf_number(stream)
register FILE *stream;
{
    register int n, i;
    n = fileno(stream);
    if ((0 <= n) && (n < STATICFIO))
	return n;
    for(i=0; i < DYNAMICFIO; ++ i) {
	if (_kassoc[i] == n)
	    return i+STATICFIO;
    }
    for(i=0; i < DYNAMICFIO; ++ i) {
	if (_kassoc[i] == -1) {
	    _kassoc[i] = n;
	    return i+STATICFIO;
	}
    }
    /* should not be reached */
    return -1;
}

ret_kiobuf_number(stream)
register FILE *stream;
{
    register int n, i;
    n = fileno(stream);
    _kiobuf[n].kanji_code = NOCONV;
    if ((0 <= n) && (n < STATICFIO))
	return;
    for(i=0; i < DYNAMICFIO; ++ i) {
	if (_kassoc[i] == n) {
	    _kassoc[i] = -1;
	    return;
	}
    }
    /* should not be reached */
}

kanji_init(stdin_kanji_code, stdout_kanji_code, stderr_kanji_code)
int stdin_kanji_code, stdout_kanji_code, stderr_kanji_code;
{
    char *kanjitype, *kanji_promptstr;
    char *escstr;
    int  l;

    if ((kanjitype = getenv("KCODE")) == NULL)
	kanjitype = KANJITYPE;

    default_kanji_code = decide_kanji_code(kanjitype);

    sprintf(kanji_in_code,  "\033%s", KANJIINCODE);
    if ((escstr = getenv("KINCODE")) != NULL) {
	switch (l = strlen(escstr)) {
	  case 0:
	    break;
	  case 1:
	    sprintf(kanji_in_code,  "\033$%s", escstr); break;
	  case 2:
	    sprintf(kanji_in_code,  "\033%s", escstr); break;
	  default:
	    strcpy(kanji_in_code,  escstr+l-3);
	}
    }
    
    sprintf(kanji_out_code, "\033%s", KANJIOUTCODE);
    if ((escstr = getenv("KOUTCODE")) != NULL) {
	switch (l = strlen(escstr)) {
	  case 0:
	    break;
	  case 1:
	    sprintf(kanji_out_code,  "\033(%s", escstr); break;
	  case 2:
	    sprintf(kanji_out_code,  "\033%s", escstr); break;
	  default:
	    strcpy(kanji_out_code,  escstr+l-3); break;
	}
    }

    if ((kanji_promptstr = getenv("KPROMPT")) == NULL)
	if ((kanji_promptstr = getenv("KMENU")) == NULL) /* backword compat. */
	    kanji_promptstr = KANJIPROMPT;
    kanji_prompt = (index("aAeEoO", *kanji_promptstr) == NULL) ? TRUE : FALSE;

    /* stdin section */
    kanji_file_init(stdin, stdin_kanji_code);
    
    /* stdout section */
    kanji_file_init(stdout, stdout_kanji_code);
    
    /* stderr section */
    kanji_file_init(stderr, stderr_kanji_code);
}

/*
 *  b. kanji_fopen(char *file_name, char *type, int kanji_code)
 *     kanji_fclose(FILE *fp)
 *     kanji_popen(char *command, char *type, int kanji_code)
 *     kanji_pclose(FILE *fp)
 *     kanji_fdopen(int fd, char *type, int kanji_code)
 */

kanji_file_init(file_pointer, kanji_code)
register FILE *file_pointer;
register int kanji_code;
{
    register int kiobuf_number;

    if (kanji_code == DEFAULT) kanji_code = default_kanji_code;
    kiobuf_number = get_kiobuf_number(file_pointer);
    _kiobuf[kiobuf_number].kanji_code = kanji_code;
    _kiobuf[kiobuf_number].kanji_input_state  = KANJI0;
    _kiobuf[kiobuf_number].kanji_output_state = KANJI0;
}

FILE *
kanji_fopen(file_name, type, kanji_code)
register char *file_name;
register char *type;
register int kanji_code;
{
    register FILE *file_pointer;

    if (kanji_code == DEFAULT)
	kanji_code = default_kanji_code;

    if ((file_pointer = fopen(file_name, type)) == NULL)
	return NULL;
    kanji_file_init(file_pointer, kanji_code);
    return file_pointer;
}

kanji_fclose(file_pointer)
register FILE *file_pointer;
{
    register int kiobuf_number;

    kiobuf_number = get_kiobuf_number(file_pointer);
    if ((_kiobuf[kiobuf_number].kanji_code == JIS) &&
	(_kiobuf[kiobuf_number].kanji_output_state != KANJI0)) {
	kanji_put_kanji_out(file_pointer);
    }
    ret_kiobuf_number(file_pointer);
    return fclose(file_pointer);
}

FILE *
kanji_popen(command, type, kanji_code)
register char *command;
register char *type;
register int kanji_code;
{
    register FILE *file_pointer;

    if (kanji_code == DEFAULT)
	kanji_code = default_kanji_code;

    if ((file_pointer = popen(command, type)) == NULL)
	return NULL;
    kanji_file_init(file_pointer, kanji_code);
    return file_pointer;
}

kanji_pclose(file_pointer)
register FILE *file_pointer;
{
    register int kiobuf_number;

    kiobuf_number = get_kiobuf_number(file_pointer);
    if ((_kiobuf[kiobuf_number].kanji_code == JIS) &&
	(_kiobuf[kiobuf_number].kanji_output_state != KANJI0)) {
	kanji_put_kanji_out(file_pointer);
    }
    ret_kiobuf_number(file_pointer);
    return pclose(file_pointer);
}

FILE *
kanji_fdopen(fd, type, kanji_code)
register int fd;
register char *type;
register int kanji_code;
{
    register FILE *file_pointer;

    if (kanji_code == DEFAULT)
	kanji_code = default_kanji_code;

    if ((file_pointer = fdopen(fd, type)) == NULL)
	return NULL;
    kanji_file_init(file_pointer, kanji_code);
    return file_pointer;
}

/*
 *  c. kanji_fseek(FILE *fp, long offset, int ptrname)
 */

kanji_fseek(file_pointer, offset, ptrname)
register FILE *file_pointer;
register long offset;
register int ptrname;
{
    register int kiobuf_number;

    kiobuf_number = get_kiobuf_number(file_pointer);
    _kiobuf[kiobuf_number].kanji_input_state = KANJI0;
    fseek(file_pointer, offset, ptrname);
}

/*
 *  d. kanji_fgetc(FILE *fp)
 *     kanji_getc(FILE *fp)
 *     kanji_getchar()
 *     kanji_gets(char *string)
 *     kanji_fgets(char *string, int length, FILE *fp)
 */

static int _kanji_icode, _kanji_istack, _kanji_istate;

kanji_get_input_property(fp)
register FILE *fp;
{
    register int kiobuf_number;

    kiobuf_number = get_kiobuf_number(fp);
    _kanji_icode  = _kiobuf[kiobuf_number].kanji_code;
    _kanji_istate = _kiobuf[kiobuf_number].kanji_input_state;
    _kanji_istack = _kiobuf[kiobuf_number].kanji_input_stack;
}

kanji_set_input_property(fp)
register FILE *fp;
{
    register int kiobuf_number;

    kiobuf_number = get_kiobuf_number(fp);
    _kiobuf[kiobuf_number].kanji_code         = _kanji_icode;
    _kiobuf[kiobuf_number].kanji_input_state = _kanji_istate;
    _kiobuf[kiobuf_number].kanji_input_stack = _kanji_istack;
}

int
kanji_fgetc_low(fp)
register FILE *fp;
{
   register int c1, c2;

   if (_kanji_istate == KANJI3) {
       _kanji_istate = KANJI2;
       return _kanji_istack;
   } else if (_kanji_istate == KANJI1) {
       _kanji_istate = KANJI0;
       return _kanji_istack;
   }

   if ((c1 = getc(fp)) == EOF)
      return EOF;

   if (c1 == '\033') { /* check escape sequence */
      c1 = getc(fp);
      c2 = getc(fp);
      if (c1 == '$') {
	 if ((c2 == '@') || (c2 == 'B')) {
	    _kanji_istate = KANJI2;
	    return kanji_fgetc_low(fp);
	 }
      }
      else if (c1 == '(') {
	 if ((c2 == 'B') || (c2 == 'H') || (c2 == 'J')) {
	    _kanji_istate = KANJI0;
	    return kanji_fgetc_low(fp);
	 }
      }
      ungetc(c2, fp);
      _kanji_istate = KANJI1;
      _kanji_istack = c1;
      return '\033';
   }
   if (_kanji_istate == KANJI2) {
      _kanji_istack = getc(fp) | 0x80;
      _kanji_istate = KANJI3;
      return c1 | 0x80;
   }

   if (c1 < 0x80) {
      return c1;
   } else {
       c2 = getc(fp);
       if ((c1 <= 0x9f) && (c1 >= 0x81) &&
	   (c2 >= 0x40) && (c2 <= 0xfc) && (c2 != 0x7f))
	   _kanji_icode = SJIS;
       else if ((c1 <= 0xea) && (c1 >= 0xe0) &&
		(c2 >= 0x40) && (c2 <= 0xa0) && (c2 != 0x7f))
	   _kanji_icode = SJIS;
       else if ((((c1 <= 0xdf) && (c1 >= 0xa1)) ||
		 ((c1 <= 0xf4) && (c1 >= 0xeb))) &&
		(c2 >= 0xa1) && (c2 <= 0xfe))
	   _kanji_icode = EUC;
       
       if (_kanji_icode == SJIS) {
	   register int o1, o2;
	   if (c2 >= 0x9f) {
	       if (c1 >= 0xe0) o1 = c1*2 - 0xe0;
	       else o1 = c1*2 - 0x60;
	       o2 = c2 + 2;
	   } else {
	       if (c1 >= 0xe0) o1 = c1*2 - 0xe1;
	       else o1 = c1*2 - 0x61;
	       if (c2 >= 0x7f) o2 = c2 + 0x60;
	       else o2 = c2 +  0x61;
	   }
	   _kanji_istack = o2;
	   c1 = o1;
       }
       else { /* EUC */
	   c1 |= 0x80;
	   _kanji_istack = c2 | 0x80;
       }
       _kanji_istate = KANJI1;
       return c1;
   }
}

int
kanji_fgetc(fp)
register FILE *fp;
{
    register int character;

    kanji_get_input_property(fp);
    if (_kanji_icode == NOCONV)
	return fgetc(fp);
    character = kanji_fgetc_low(fp);
    kanji_set_input_property(fp);
    return character;
}

char *
kanji_gets(s)
register char *s;
{
    register int c;
    register char *base;

    kanji_get_input_property(stdin);
    if (_kanji_icode == NOCONV)
	return gets(s);
    base = s;
    do {
	*s++ = c = kanji_fgetc_low(stdin);
    } while((c != '\n') && (c != EOF));
    kanji_set_input_property(stdin);

    *(--s) = '\0';
    if (s == base) return NULL;
    else return base;
}

char *
kanji_fgets(s, n, fp)
register char *s;
register int n;
register FILE *fp;
{
    register int c;
    register char *base;

    kanji_get_input_property(fp);
    if (_kanji_icode == NOCONV)
	return fgets(s, n, fp);
    c = 0;
    base = s;
    while ( --n > 0 ) {
	*s++ = c = kanji_fgetc_low(fp);
	if ((c == '\n') || (c == EOF)) break;
    }
    kanji_set_input_property(fp);

    if (c == EOF) {
	*(--s) = '\0';
	if (base == s) return NULL;
	else return base;
    }
    *s = '\0';
    return base;
}

/*
 *  e. kanji_fputc(int character, FILE *fp)
 *     kanji_fputs(unsigned char *string, FILE *fp)
 *     kanji_printf(char *format, ,,,)
 *     kanji_fprintf(FILE *fp, char *format, ,,,)
 */

static int _kanji_ocode, _kanji_ostack, _kanji_ostate;
static int _kanji_stdout_state=KANJI0;

kanji_get_output_property(fp)
register FILE *fp;
{
    register int kiobuf_number;

    kiobuf_number = get_kiobuf_number(fp);
    _kanji_ocode  = _kiobuf[kiobuf_number].kanji_code;
    _kanji_ostate = _kiobuf[kiobuf_number].kanji_output_state;
    _kanji_ostack = _kiobuf[kiobuf_number].kanji_output_stack;

    if ((fp == stdout) || (fp == stderr)) {
	if (_kanji_stdout_state != _kanji_ostate) {
	    if (fp == stdout)
		fflush(stderr);
	    else
		fflush(stdout);
	    if (_kanji_stdout_state == KANJI0) {
		kanji_put_kanji_out(fp);
		_kanji_ostate = KANJI0;
	    } else {
		kanji_put_kanji_in(fp);
		_kanji_ostate = KANJI2;
	    }
	}
    }
}

kanji_set_output_property(fp)
register FILE *fp;
{
    register int kiobuf_number;

    kiobuf_number = get_kiobuf_number(fp);
    _kiobuf[kiobuf_number].kanji_output_state = _kanji_ostate;
    _kiobuf[kiobuf_number].kanji_output_stack = _kanji_ostack;

    if ((fp == stdout) || (fp == stderr)) {
	_kanji_stdout_state = _kanji_ostate;
    }
}

kanji_put_kanji_in(fp)
register FILE *fp;
{
    fputs(kanji_in_code, fp);
}

kanji_put_kanji_out(fp)
register FILE *fp;
{
    fputs(kanji_out_code, fp);
}

int kanji_fputc_low(character, fp)
register int character;
register FILE *fp;
{
    register int status = 0;
    switch(_kanji_ostate) {
      case KANJI0:
	if (character & 0x80) {
	    if (_kanji_ocode == JIS) /* kanji_in sequence for JIS */
		kanji_put_kanji_in(fp);
	    _kanji_ostack = character;
	    _kanji_ostate = KANJI1;
	}
	else
	    status = putc(character, fp);
	break;
      case KANJI1:
	if (character & 0x80) {
	    switch (_kanji_ocode) {
	      case JIS: /* JIS */
		putc(_kanji_ostack & 0x7f, fp);
		status = putc(character & 0x7f, fp);
		break;
	      case SJIS: /* Shift-JIS */
		if (_kanji_ostack & 1) {
		    _kanji_ostack = _kanji_ostack/2 +
			((_kanji_ostack < 0xdf) ? 0x31 : 0x71);
		    character = character -
			((character >= 0xe0) ? 0x60 : 0x61);
		} else {
		    _kanji_ostack = _kanji_ostack/2 +
			((_kanji_ostack < 0xdf) ? 0x30 : 0x70);
		    character = character - 2;
		}
		putc(_kanji_ostack, fp);
		status = putc(character, fp);
		break;
	      default: /* EUC(DEC) */
		putc(_kanji_ostack, fp);
		status = putc(character, fp);
	    }
	    _kanji_ostate = KANJI2;
	}
	else { /* Error? */
	    if (_kanji_ocode == JIS) /* kanji-out sequence JIS */
		kanji_put_kanji_out(fp);
	    putc(_kanji_ostack & 0x7f, fp);
	    status = putc(character, fp);
	    _kanji_ostate = KANJI0;
	}
	break;
      case KANJI2:
	if (character & 0x80) {
	    _kanji_ostack = character ;
	    _kanji_ostate = KANJI1;
	}
	else {
	    if (_kanji_ocode == JIS) /* kanji-out sequence for JIS */
		kanji_put_kanji_out(fp);
	    status = putc(character, fp);
	    _kanji_ostate = KANJI0;
	}
    }
    return status;
}

int
kanji_fputc(character, fp)
register unsigned int character;
register FILE *fp;
{
    register int status;

    kanji_get_output_property(fp);
    if (_kanji_ocode == NOCONV)
	return putc(character, fp);
    status = kanji_fputc_low(character&0xff, fp);
    kanji_set_output_property(fp);
    return status;
}

int
kanji_fputs(string, fp)
register unsigned char *string;
register FILE *fp;
{
    register int status;

    kanji_get_output_property(fp);
    if (_kanji_ocode == NOCONV)
	return fputs((char *)string, fp);
    while((*string) != '\0') {
	status = kanji_fputc_low(*(string++), fp);
    }
    kanji_set_output_property(fp);
    return status;
}

unsigned char kanjistr[32768];
/*VARARGS0*/
int kanji_printf(va_alist)
va_dcl
{
   va_list args;
   char *fmt;
   int  len;

   va_start(args);
   fmt = va_arg(args, char *);
#if defined(INTSPRINTF) || defined(NEED_VSPRINTF)
   len = vsprintf(kanjistr, fmt, args);
#else
   vsprintf(kanjistr, fmt, args);
   len = strlen(kanjistr);
#endif
   va_end(args);

   kanji_fputs(kanjistr, stdout);
   return len;
}

/*VARARGS0*/
int kanji_fprintf(va_alist)
va_dcl
{
   va_list args;
   FILE *stream;
   char *fmt;
   int  len;

   va_start(args);
   stream = va_arg(args, FILE *);
   fmt = va_arg(args, char *);
#if defined(INTSPRINTF) || defined(NEED_VSPRINTF)
   len = vsprintf(kanjistr, fmt, args);
#else
   vsprintf(kanjistr, fmt, args);
   len = strlen(kanjistr);
#endif
   va_end(args);

   kanji_fputs(kanjistr, stream);
   return len;
}

/*VARARGS0*/
int kanji_vprintf(fmt, args)
char *fmt;
va_list args;
{
   int  len;

#if defined(INTSPRINTF) || defined(NEED_VSPRINTF)
   len = vsprintf(kanjistr, fmt, args);
#else
   vsprintf(kanjistr, fmt, args);
   len = strlen(kanjistr);
#endif
   va_end(args);

   kanji_fputs(kanjistr, stdout);
   return len;
}

/*
 *  f. kanji_fread (char *ptr, int size, int nitems, FILE *stream)
 *     kanji_fwrite(char *ptr, int size, int nitems, FILE *stream)
 */

int
kanji_fread (ptr, size, nitems, fp)
register unsigned char *ptr;
int size;
int nitems;
register FILE *fp;
{
    register int n, c;

    kanji_get_input_property(fp);
    if (_kanji_icode == NOCONV) {
	return fread (ptr, size, nitems, fp);
    }

    n = size*nitems;
    while ( n-- > 0 ) {
	c = kanji_fgetc_low(fp);
	if (c == EOF) break;
	*ptr++ = c;
    }
    kanji_set_input_property(fp);

    return nitems - (n+1)/size;
}

int
kanji_fwrite (ptr, size, nitems, fp)
register unsigned char *ptr;
int size;
int nitems;
register FILE *fp;
{
    register int n;

    kanji_get_output_property(fp);
    if (_kanji_ocode == NOCONV) {
	return fwrite (ptr, size, nitems, fp);
    }

    n = size*nitems;
    while ( n-- > 0 ) {
	if(kanji_fputc_low(*ptr++, fp) == EOF) break;
    }
    kanji_set_output_property(fp);

    return nitems - (n+1)/size;
}

/*
 *
 *  g. kanji_cvins (char *ptr)
 *
 */

int kanji_cvins (ptr)
char *ptr;
{
    char *p, *q;
    int kanji_flag;

    kanji_flag = 0;
    for (p = q = ptr; *p != '\0'; p ++) {
	if ((p[0] == '\033') && (p[1] == '$') &&
	    ((p[2] == '@') || (p[2] == 'B'))) {
	    kanji_flag = 1;
	    p += 2;
	} else 	if ((p[0] == '\033') && (p[1] == '(') &&
		    ((p[2] == 'B') || (p[2] == 'J'))) {
	    kanji_flag = 0;
	    p += 2;
	} else if ((kanji_flag != 0) && (p[1] != '\0')) {
	    *(q ++) = *(p ++) | 0x80;
	    *(q ++) = *p | 0x80;
	} else {
	    *(q ++) = *p;
	}
    }
    *q = '\0';
    return (q - ptr) + 1;
}

/* $B$3$l0J9_$O(B vsprintf $B$N8_49%k!<%A%s$G$9(B */

#ifdef NEED_VSPRINTF
#define LONGINT

/* Portable vsprintf  by Robert A. Larson <blarson@skat.usc.edu> */

/* Copyright 1989 Robert A. Larson.
 * Distribution in any form is allowed as long as the author
 * retains credit, changes are noted by their author and the
 * copyright message remains intact.  This program comes as-is
 * with no warentee of fitness for any purpouse.
 *
 * Thanks to Doug Gwen, Chris Torek, and others who helped clarify
 * the ansi printf specs.
 *
 * Please send any bug fixes and improvments to blarson@skat.usc.edu .
 * The use of goto is NOT a bug.
 */

/* Feb	7, 1989		blarson		First usenet release */

/* This code implements the vsprintf function, without relying on
 * the existance of _doprint or other system specific code.
 *
 * Define NOVOID if void * is not a supported type.
 *
 * Two compile options are available for efficency:
 *	INTSPRINTF	should be defined if sprintf is int and returns
 *			the number of chacters formated.
 *	LONGINT		should be defined if sizeof(long) == sizeof(int)
 *
 *	They only make the code smaller and faster, they need not be
 *	defined.
 *
 * UNSIGNEDSPECIAL should be defined if unsigned is treated differently
 * than int in argument passing.  If this is definded, and LONGINT is not,
 * the compiler must support the type unsingned long.
 *
 * Most quirks and bugs of the available sprintf fuction are duplicated,
 * however * in the width and precision fields will work correctly
 * even if sprintf does not support this, as will the n format.
 *
 * Bad format strings, or those with very long width and precision
 * fields (including expanded * fields) will cause undesired results.
 */

/* This must be a typedef not a #define! */
#ifdef void
typedef void *pointer;
#else
typedef char *pointer;
#endif

#ifdef	INTSPRINTF
#define Sprintf(string,format,arg)	(sprintf((string),(format),(arg)))
#else
#define Sprintf(string,format,arg)	(sprintf((string),(format),(arg)),strlen(string))
#endif

#if defined(__STDC__) && !defined(NOSTDHDRS)
#include <stdarg.h>
#else
#include <varargs.h>
#endif

typedef int *intp;

int vsprintf(dest, format, args)
char *dest;
register char *format;
va_list args;
{
    register char *dp = dest;
    register char c;
    register char *tp;
    char tempfmt[64];
#ifndef LONGINT
    int longflag;
#endif

    tempfmt[0] = '%';
    while(c = *format++) {
	if(c=='%') {
	    tp = &tempfmt[1];
#ifndef LONGINT
	    longflag = 0;
#endif
continue_format:
	    switch(c = *format++) {
		case 's':
		    *tp++ = c;
		    *tp = '\0';
		    dp += Sprintf(dp, tempfmt, va_arg(args, char *));
		    break;
		case 'u':
		case 'x':
		case 'o':
		case 'X':
#ifdef UNSIGNEDSPECIAL
		    *tp++ = c;
		    *tp = '\0';
#ifndef LONGINT
		    if(longflag)
			dp += Sprintf(dp, tempfmt, va_arg(args, unsigned long));
		    else
#endif
			dp += Sprintf(dp, tempfmt, va_arg(args, unsigned));
		    break;
#endif
		case 'd':
		case 'c':
		case 'i':
		    *tp++ = c;
		    *tp = '\0';
#ifndef LONGINT
		    if(longflag)
			dp += Sprintf(dp, tempfmt, va_arg(args, long));
		    else
#endif
			dp += Sprintf(dp, tempfmt, va_arg(args, int));
		    break;
		case 'f':
		case 'e':
		case 'E':
		case 'g':
		case 'G':
		    *tp++ = c;
		    *tp = '\0';
		    dp += Sprintf(dp, tempfmt, va_arg(args, double));
		    break;
		case 'p':
		    *tp++ = c;
		    *tp = '\0';
		    dp += Sprintf(dp, tempfmt, va_arg(args, pointer));
		    break;
		case '-':
		case '+':
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case '.':
		case ' ':
		case '#':
		case 'h':
		    *tp++ = c;
		    goto continue_format;
		case 'l':
#ifndef LONGINT
		    longflag = 1;
		    *tp++ = c;
#endif
		    goto continue_format;
		case '*':
		    tp += Sprintf(tp, "%d", va_arg(args, int));
		    goto continue_format;
		case 'n':
		    *va_arg(args, intp) = dp - dest;
		    break;
		case '%':
		default:
		    *dp++ = c;
		    break;
	    }
	} else *dp++ = c;
    }
    *dp = '\0';
    return dp - dest;
}

#endif

