/*
 *  $B4A;z$r;HMQ$9$k$9$Y$F$N(B C $B%W%m%0%i%`$+$i8F$S=P$5$l$k6&DL$N%X%C%@!<$G!"(B
 *  kanji_config.h $B$r7PM3$7$F;HMQ$5$l$^$9!#(B
 *
 *  NOKANJI -- $B$3$NJQ?t$,(B define $B$5$l$F$$$k$H(B kanji_* $B$X$NCV$-49$($r(B
 *             $B9T$$$^$;$s!#(B
 *
 *  KINTERN -- $B$3$NJQ?t(B kanji.c $B$+$i8F$P$l$?>l9g$N$_(B KINTERN $B$,@k8@$5(B
 *             $B$l$^$9!#JQ?t$N<BBN$N@k8@$H=i4|2=$r9T$$!"$^$?8e$KB3$/%X%C(B
 *             $B%@!<$N$?$a$K(B KEXT $B$H(B KINIT $B$r@_Dj$7$^$9!#(B
 *
 */

#ifndef  NOKANJI

#ifdef  KINTERN
#define KEXT
#define KINIT(v) = v
#else
#define KEXT extern
#define KINIT(v)
#endif

/*
 *  $B4A;z%3!<%IL>$NDj5A(B
 */

#define NOCONV -1
#define DEFAULT 0
#define JIS     1
#define EUC     2
#define SJIS    3

/*
 *  $B%G%U%)%k%H$N4A;z%3!<%I(B
 */

KEXT int default_kanji_code KINIT(DEFAULT);

/*
 * $B4A;zF~=PNO$N$?$a$N9=B$BN(B
 */

#define STATICFIO 32
#define DYNAMICFIO 32
#define MAXFIO STATICFIO+DYNAMICFIO

KEXT struct {
    int kanji_code;
    int kanji_input_state, kanji_input_stack;
    int kanji_output_state, kanji_output_stack;
} _kiobuf[MAXFIO];

KEXT int _kassoc[DYNAMICFIO];

#define KANJI0  0   /* GL $B$K4A;zJ8;z%;%C%H$,;X<($5$l$F$$$J$$(B */
#define KANJI1  1   /* 1 Byte $B;D$C$F$$$F(B stack $B$K@Q$^$l$F$$$k(B */
#define KANJI2  2   /* GL $B$K4A;zJ8;z%;%C%H$,;X<($5$l$F$$$k(B */
#define KANJI3  3   /* GL $B$K4A;zJ8;z%;%C%H$,;X<($5$l$F$$$F(B 1 Byte $B;D$C$F$$$k(B */


/* $B$=$NB>$NJQ?t$NDj5A(B */

KEXT char kanji_in_code[5];
KEXT char kanji_out_code[5];
KEXT int kanji_prompt;	/* kanji prompt TRUE=kanji, FALSE=original */

/*
 * $B4A;zF~=PNO4X?t$NCV$-49$((B
 */

#ifndef  KINTERN
#  ifdef   putc 
#    undef  putc
#  endif
#  ifdef   putchar
#    undef  putchar
#  endif
#  ifdef   getc
#    undef  getc
#  endif
#  define fopen kanji_fopen
#  define fclose kanji_fclose
#  define popen kanji_popen
#  define pclose kanji_pclose
#  define fdopen kanji_fdopen
#  define fseek kanji_fseek
#  define fgetc kanji_fgetc
#  define getc kanji_fgetc
#  define gets kanji_gets
#  define fgets kanji_fgets
#  define putc kanji_fputc
#  define fputc kanji_fputc
#  define putchar(x) kanji_fputc(x, stdout)
#  define puts(x) kanji_fputs(x, stdout)
#  define fputs kanji_fputs
#  define printf kanji_printf
#  define fprintf kanji_fprintf
#  ifdef INTSPRINTF
extern int   kanji_sprintf();
#  else
extern char *kanji_sprintf();
#  endif /* INTSPRINTF */
#  define vprintf kanji_vprintf
#  define fread kanji_fread
#  define fwrite kanji_fwrite

extern FILE *kanji_fopen();
extern int   kanji_fclose(), kanji_fseek();
extern int   kanji_fgetc();
extern char *kanji_gets(), *kanji_fgets();
extern FILE *kanji_popen();
extern int   kanji_pclose();
extern FILE *kanji_fdopen();
extern int  kanji_fread(), kanji_fwrite();
extern int  kanji_fputc(), kanji_fputs(), kanji_fprintf(), kanji_printf();
#endif /*KINTERN*/

#endif /*NOKANJI*/
