/*
 *  $BF|K\8l%a%C%;!<%8$r%W%m%0%i%`Cf$KKd$a9~$`%k!<%A%s(B
 */

/*
 *  $B<!$N(B MIXTURE $B$r(B define $B$9$k$H!"%a%C%;!<%8$,N>J}Kd$a9~$^$l$k!#(B
 *  program $BCf$N(B kanji_prompt $B$H$$$&JQ?t$G%3%s%H%m!<%k$5$l$k!#(B
 */

#ifndef JPNONLY
#define MIXTURE
#endif

/*
 *  VERBOSE $B$r(B define $B$9$k$H!"%3%s%Q%$%k;~$K%a%C%;!<%8$,=P$k!#(B
 */

/*#define VERBOSE*/


#include <stdio.h>

#define ARSIZE 4096
#define FNAMESIZE 256

unsigned char eng[ARSIZE], jpn[ARSIZE];
unsigned char line[ARSIZE];

char *strcat();

main(argc, argv)
int argc;
char *argv[];
{
    FILE *tblfp;
    char name[FNAMESIZE];

    if (argc != 2) {
	fprintf(stderr, "Usage: %s file-name\n", argv[0]);
	exit (1);
    }
    if ((tblfp = fopen("EJ-TABLE", "r")) == NULL) {
	noconvert(argv[1]);
	exit(0);
    }
    sprintf(name, "F%s\n", argv[1]);
    while(fgets(line, ARSIZE, tblfp)) {
	if (strcmp(name, line) == 0) {
#ifdef VERBOSE
	    fprintf(stderr, "found: table for %s\n", argv[1]);
#endif
	    convert(argv[1], tblfp);
	    exit(0);
	}
    }
#ifdef VERBOSE
    fprintf(stderr, "not found: table for %s\n", argv[1]);
#endif
    noconvert(argv[1]);
    exit(0);
}

convert(file_name, tblfp)
char *file_name;
FILE *tblfp;
{
    FILE *srcfp;
    long cp, st, nt;
    unsigned char *ep;
    int c, c1, i;

    if ((srcfp = fopen(file_name, "r")) == NULL) {
	perror(file_name);
	exit (1);
    }
    cp = 0; /* pointer to start of copy */
    while (get_convert(tblfp, eng, jpn)) {
	fseek (srcfp, cp, 0);
	c1 = eng[0];
      next_char:
	if ((c = getc(srcfp)) == EOF) {
	    fprintf(stderr, "string not found: %s\n", eng);
	    continue; /* "eng" string not found, skip next pattern */
	}
	if (c != c1) goto next_char;
	st = ftell(srcfp);
	for (ep = eng+1; *ep != '\0'; ++ ep) {
	    c = getc(srcfp);
	    if (c != *ep) {
		fseek(srcfp, st, 0);
		goto next_char;
	    }
	}
	nt = ftell(srcfp);
	fseek(srcfp, cp, 0);
	for (i = cp; i < st-1; ++ i)
	    putc(getc(srcfp), stdout);
#ifdef MIXTURE
	fputs("( kanji_prompt ? \n",stdout);
#endif
	fputs(jpn, stdout);
#ifdef MIXTURE
	fputs(":\n",stdout);
	fputs(eng, stdout);
	fputs(")\n", stdout);
#endif
	fseek(srcfp, nt, 0);
	cp = nt;
    }
    fseek(srcfp, cp, 0);
    while(fgets(line, ARSIZE, srcfp))
	fputs(line, stdout);
}

unsigned char jis[ARSIZE];

get_convert(tblfp, eng, jpn)
FILE *tblfp;
unsigned char *eng, *jpn;
{
    long pos;
    /* get English line */
  retry:
    eng[0] = '\0';
    do {
	if (fgets(line, ARSIZE, tblfp) == NULL) return 0;
	if (line[0] == 'F') return 0;
	while(line[0] != 'E') {
	    if (fgets(line, ARSIZE, tblfp) == NULL) return 0;
	    if (line[0] == 'F') return 0;
	}
	strcat(eng, line + 1);
    } while(eng[strlen(eng)-2] != '"');

    jis[0] = '\0';
    do {
	pos = ftell(tblfp);
	if (fgets(line, ARSIZE, tblfp) == NULL) return 0;
	if (line[0] == 'F') return 0;
	while(line[0] != 'J') {
	    if (line[0] == 'E') {
		fseek(tblfp, pos, 0);
		goto retry;
	    }
	    pos = ftell(tblfp);
	    if (fgets(line, ARSIZE, tblfp) == NULL) return 0;
	    if (line[0] == 'F') return 0;
	}
	strcat(jis, line + 1);
    } while(jis[strlen(jis)-2] != '"');

    jis2euc(jpn, jis);
    if (eng[strlen(eng)-1] == '\n') eng[strlen(eng)-1] = '\0';
    if (jpn[strlen(jpn)-1] == '\n') jpn[strlen(jpn)-1] = '\0';
    return 1;
}

jis2euc(jpn, jis)
unsigned char *jpn, *jis;
{
    int kanji_start = 0;
    unsigned char *line_top;

    line_top = jpn;

    while(*jis) {
	if ((jpn - line_top > 150) && (*jis != '\n')) /* fold long lines */
	    if (*(jpn-1) != '\\') {
		*jpn++ = '\\';
		*jpn++ = '\n';
		line_top = jpn;
	    }
	if (*jis == 033) {
	    if (jis[1] == '$') {
		if ((jis[2] == '@') || (jis[2] == 'B')) {
		    kanji_start = 1;
		    jis += 3;
		    continue;
		}
	    } else if (jis[1] == '(') {
		if ((jis[2] == 'B') || (jis[2] == 'H') || (jis[2] == 'J')) {
		    kanji_start = 0;
		    jis += 3;
		    continue;
		}
	    }
	}
	if (kanji_start) {
	    int c;
	    c = (unsigned char)(*jis) + 0200;
	    *jpn++ = '\\';
	    *jpn++ = ((c >> 6) & 7) + '0';
	    *jpn++ = ((c >> 3) & 7) + '0';
	    *jpn++ = (c & 7) + '0';
	} else {
	    *jpn++ = *jis;
	    if (*jis == '\n') line_top = jpn;
	}
	jis ++;
    }
    *jpn = '\0';
}

noconvert(file_name)
char *file_name;
{
    FILE *srcfp;
    register int c;

    if ((srcfp = fopen(file_name, "r")) == NULL) {
	perror(file_name);
	exit (1);
    }
    while((c = fgetc(srcfp))!=EOF)
	putchar(c);
}
